/**
 * 
 */
package com.google.code.joto.procesors;

import java.util.Date;

import com.google.code.joto.CustomProcessor;
import com.google.code.joto.ProcessMoreCallback;
import com.google.code.joto.ReverseEngineerData;

/**
 * @author epere4
 * @author liliana.nu
 */
public class DateProcessor
    implements CustomProcessor
{

    /**
     * @see com.google.code.joto.CustomProcessor#canProcessThis(java.lang.Object)
     */
    public boolean canProcessThis( Object objectToProcess )
    {
        return objectToProcess instanceof Date;
    }

    /**
     * @see com.google.code.joto.CustomProcessor#processThis(java.lang.Object, com.google.code.joto.ReverseEngineerData, int, com.google.code.joto.ProcessMoreCallback)
     */
    public void processThis( Object objectToProcess, ReverseEngineerData sharedData, int depthLevel,
                             ProcessMoreCallback callback )
        throws Exception
    {
        sharedData.addClassToImport( Date.class );
        Date dateToProcess = (Date) objectToProcess;
        sharedData.concat( "new Date(", dateToProcess.getTime(), "L) /* ", dateToProcess, "*/ " );

    }

}
